.\" Copyright (c) 1996 Doug Rabson
.\"
.\" All rights reserved.
.\"
.\" This program is free software.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/VOP_ADVLOCK.9,v 1.6.2.3 2001/12/17 11:30:18 ru Exp $
.\" $DragonFly: src/share/man/man9/VOP_ADVLOCK.9,v 1.5 2007/12/02 22:57:58 swildner Exp $
.\"
.Dd June 30, 1999
.Os
.Dt VOP_ADVLOCK 9
.Sh NAME
.Nm VOP_ADVLOCK
.Nd advisory record locking
.Sh SYNOPSIS
.In sys/param.h
.In sys/vnode.h
.In sys/fcntl.h
.In sys/lockf.h
.Ft int
.Fn VOP_ADVLOCK "struct vnode *vp" "caddr_t id" "int op" "struct flock *fl" "int flags"
.Sh DESCRIPTION
The arguments are:
.Bl -tag -width flags
.It Fa vp
the vnode being manipulated
.It Fa id
the id token which is changing the lock
.It Fa op
the operation to perform (see
.Xr fcntl 2 )
.It Fa fl
description of the lock
.It Fa flags
One of more of the following:
.Bl -column F_UNLCK -offset indent
.It Dv F_RDLCK Ta "shared or read lock"
.It Dv F_UNLCK Ta "unlock"
.It Dv F_WRLCK Ta "exclusive or write lock"
.It Dv F_WAIT Ta "Wait until lock is granted"
.It Dv F_POSIX Ta "Use POSIX semantics for lock"
.El
.El
.Pp
This entry point manipulates advisory record locks on the file.  Most
filesystems delegate the work for this call to
.Fn lf_advlock .
.Sh RETURN VALUES
Zero is returned on success, otherwise an error is returned.
.Sh SEE ALSO
.Xr fcntl 2 ,
.Xr flock 2 ,
.Xr vnode 9
.Sh AUTHORS
This man page was written by
.An Doug Rabson .
